/* C code for program Analyzer, generated by snc from ../Analyzer.st */
#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <limits.h>

#include "seq_snc.h"
# line 13 "../Analyzer.st"
#include <math.h>
# line 23 "../Analyzer.st"
static const EF_ID theta_ef = 1;
# line 24 "../Analyzer.st"
static const EF_ID track_ef = 2;
# line 25 "../Analyzer.st"
static const EF_ID synchro_ef = 3;
# line 26 "../Analyzer.st"
static const EF_ID length_ef = 4;

/* Variable declarations */
# line 15 "../Analyzer.st"
static	double theta;
# line 16 "../Analyzer.st"
static	double detector;
# line 17 "../Analyzer.st"
static	double length;
# line 18 "../Analyzer.st"
static	double kbenergy;
# line 19 "../Analyzer.st"
static	double analdsp;
# line 20 "../Analyzer.st"
static	int track;
# line 21 "../Analyzer.st"
static	int synchro;
# line 28 "../Analyzer.st"
static	double dtor;
# line 29 "../Analyzer.st"
static	double theta_old;
# line 30 "../Analyzer.st"
static	double offset;


/* Function declarations */

#define seqg_var (*(struct seqg_vars *const *)seqg_env)

/* Program init func */
static void seqg_init(PROG_ID seqg_env)
{
}

/****** Code for state "init" in state set "Analyzer" ******/

/* Event function for state "init" in state set "Analyzer" */
static seqBool seqg_event_Analyzer_0_init(SS_ID seqg_env, int *seqg_ptrn, int *seqg_pnst)
{
	if (TRUE)
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "init" in state set "Analyzer" */
static void seqg_action_Analyzer_0_init(SS_ID seqg_env, int seqg_trn, int *seqg_pnst)
{
	switch(seqg_trn)
	{
	case 0:
		{
# line 35 "../Analyzer.st"
			dtor = atan(1.) / 45.;
# line 36 "../Analyzer.st"
			if (length < 0.1)
			{
# line 37 "../Analyzer.st"
				length = 1000.0;
# line 38 "../Analyzer.st"
				seq_pvPutTmo(seqg_env, 2/*length*/, DEFAULT, DEFAULT_TIMEOUT);
			}
# line 40 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 2/*length*/, DEFAULT, DEFAULT_TIMEOUT);
# line 41 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 1/*detector*/, DEFAULT, DEFAULT_TIMEOUT);
# line 42 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 3/*kbenergy*/, DEFAULT, DEFAULT_TIMEOUT);
# line 43 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 4/*analdsp*/, DEFAULT, DEFAULT_TIMEOUT);
# line 44 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 0/*theta*/, DEFAULT, DEFAULT_TIMEOUT);
# line 45 "../Analyzer.st"
			offset = detector - length * cos(2. * dtor * theta);
# line 46 "../Analyzer.st"
			theta_old = theta;
# line 47 "../Analyzer.st"
			printf("\nAnalyzer starting at detector,theta");
# line 48 "../Analyzer.st"
			printf("   = %13.8f, %13.8f\n", detector, theta);
# line 49 "../Analyzer.st"
			seq_efClear(seqg_env, synchro_ef);
# line 50 "../Analyzer.st"
			seq_efClear(seqg_env, length_ef);
# line 51 "../Analyzer.st"
			seq_efClear(seqg_env, theta_ef);
		}
		return;
	}
}

/****** Code for state "monitor_changes" in state set "Analyzer" ******/

/* Event function for state "monitor_changes" in state set "Analyzer" */
static seqBool seqg_event_Analyzer_0_monitor_changes(SS_ID seqg_env, int *seqg_ptrn, int *seqg_pnst)
{
# line 56 "../Analyzer.st"
	if (seq_efTestAndClear(seqg_env, theta_ef))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 0;
		return TRUE;
	}
# line 72 "../Analyzer.st"
	if (seq_efTestAndClear(seqg_env, synchro_ef) || seq_efTestAndClear(seqg_env, length_ef))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 1;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "monitor_changes" in state set "Analyzer" */
static void seqg_action_Analyzer_0_monitor_changes(SS_ID seqg_env, int seqg_trn, int *seqg_pnst)
{
	switch(seqg_trn)
	{
	case 0:
		{
# line 57 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 5/*track*/, DEFAULT, DEFAULT_TIMEOUT);
# line 58 "../Analyzer.st"
			if (track)
			{
# line 59 "../Analyzer.st"
				seq_pvGetTmo(seqg_env, 1/*detector*/, DEFAULT, DEFAULT_TIMEOUT);
# line 60 "../Analyzer.st"
				seq_pvGetTmo(seqg_env, 0/*theta*/, DEFAULT, DEFAULT_TIMEOUT);
# line 61 "../Analyzer.st"
				seq_pvGetTmo(seqg_env, 2/*length*/, DEFAULT, DEFAULT_TIMEOUT);
# line 63 "../Analyzer.st"
				detector = offset + length * cos(2 * dtor * theta);
# line 64 "../Analyzer.st"
				printf("Analyzer: detector  ->  %13.8f\n", detector);
# line 65 "../Analyzer.st"
				seq_pvPutTmo(seqg_env, 1/*detector*/, DEFAULT, DEFAULT_TIMEOUT);
# line 66 "../Analyzer.st"
				theta_old = theta;
			}
# line 68 "../Analyzer.st"
			seq_efClear(seqg_env, synchro_ef);
# line 69 "../Analyzer.st"
			seq_efClear(seqg_env, length_ef);
# line 70 "../Analyzer.st"
			seq_efClear(seqg_env, theta_ef);
		}
		return;
	case 1:
		{
# line 73 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 2/*length*/, DEFAULT, DEFAULT_TIMEOUT);
# line 74 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 1/*detector*/, DEFAULT, DEFAULT_TIMEOUT);
# line 75 "../Analyzer.st"
			seq_pvGetTmo(seqg_env, 0/*theta*/, DEFAULT, DEFAULT_TIMEOUT);
# line 76 "../Analyzer.st"
			offset = detector - length * cos(2. * dtor * theta);
# line 77 "../Analyzer.st"
			theta_old = theta;
# line 78 "../Analyzer.st"
			printf("Analyzer: offset  ->  %13.8f\n", offset);
# line 79 "../Analyzer.st"
			synchro = 0;
# line 80 "../Analyzer.st"
			seq_pvPutTmo(seqg_env, 6/*synchro*/, DEFAULT, DEFAULT_TIMEOUT);
# line 81 "../Analyzer.st"
			seq_efClear(seqg_env, synchro_ef);
# line 82 "../Analyzer.st"
			seq_efClear(seqg_env, length_ef);
# line 83 "../Analyzer.st"
			seq_efClear(seqg_env, theta_ef);
		}
		return;
	}
}

#undef seqg_var

/************************ Tables ************************/

/* Channel table */
static seqChan seqg_chans[] = {
	/* chName, offset, varName, varType, count, eventNum, efId, monitored, queueSize, queueIndex */
	{"{P}{THETA}", (size_t)&theta, "theta", P_DOUBLE, 1, 5, 1, 1, 0, 0},
	{"{P}{DETECTOR}", (size_t)&detector, "detector", P_DOUBLE, 1, 6, 0, 1, 0, 0},
	{"{P}{ANAL}length", (size_t)&length, "length", P_DOUBLE, 1, 7, 4, 1, 0, 0},
	{"{P}{ANAL}kbenergy", (size_t)&kbenergy, "kbenergy", P_DOUBLE, 1, 8, 0, 1, 0, 0},
	{"{P}{ANAL}analdsp", (size_t)&analdsp, "analdsp", P_DOUBLE, 1, 9, 0, 1, 0, 0},
	{"{P}{ANAL}track", (size_t)&track, "track", P_INT, 1, 10, 2, 1, 0, 0},
	{"{P}{ANAL}sync", (size_t)&synchro, "synchro", P_INT, 1, 11, 3, 1, 0, 0},
};

/* Event masks for state set "Analyzer" */
static const seqMask seqg_mask_Analyzer_0_init[] = {
	0x00000000,
};
static const seqMask seqg_mask_Analyzer_0_monitor_changes[] = {
	0x0000001a,
};

/* State table for state set "Analyzer" */
static seqState seqg_states_Analyzer[] = {
	{
	/* state name */        "init",
	/* action function */   seqg_action_Analyzer_0_init,
	/* event function */    seqg_event_Analyzer_0_init,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  seqg_mask_Analyzer_0_init,
	/* state options */     (0)
	},
	{
	/* state name */        "monitor_changes",
	/* action function */   seqg_action_Analyzer_0_monitor_changes,
	/* event function */    seqg_event_Analyzer_0_monitor_changes,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  seqg_mask_Analyzer_0_monitor_changes,
	/* state options */     (0)
	},
};

/* State set table */
static seqSS seqg_statesets[] = {
	{
	/* state set name */    "Analyzer",
	/* states */            seqg_states_Analyzer,
	/* number of states */  2
	},
};

/* Program table (global) */
seqProgram Analyzer = {
	/* magic number */      2002002,
	/* program name */      "Analyzer",
	/* channels */          seqg_chans,
	/* num. channels */     7,
	/* state sets */        seqg_statesets,
	/* num. state sets */   1,
	/* user var size */     0,
	/* param */             "P=13IDC:,THETA=m43, DETECTOR=m44, ANAL = ANAL",
	/* num. event flags */  4,
	/* encoded options */   (0 | OPT_CONN | OPT_NEWEF),
	/* init func */         seqg_init,
	/* entry func */        0,
	/* exit func */         0,
	/* num. queues */       0
};

/* Register sequencer commands and program */
#include "epicsExport.h"
static void AnalyzerRegistrar (void) {
    seqRegisterSequencerCommands();
    seqRegisterSequencerProgram (&Analyzer);
}
epicsExportRegistrar(AnalyzerRegistrar);
