/* C code for program GSE_MonoEnergy, generated by snc from ../GSE_MonoEnergy.st */
#include <string.h>
#include <stddef.h>
#include <stdio.h>
#include <limits.h>

#include "seq_snc.h"
# line 35 "../GSE_MonoEnergy.st"
#include <math.h>
# line 36 "../GSE_MonoEnergy.st"
#include <epicsThread.h>
# line 37 "../GSE_MonoEnergy.st"
#include "GSE_MonoSupport.h"
# line 114 "../GSE_MonoEnergy.st"
static const EF_ID ef_en = 1;
# line 115 "../GSE_MonoEnergy.st"
static const EF_ID ef_id_set_off = 2;
# line 116 "../GSE_MonoEnergy.st"
static const EF_ID ef_y2_track = 3;
# line 117 "../GSE_MonoEnergy.st"
static const EF_ID ef_width = 4;
# line 118 "../GSE_MonoEnergy.st"
static const EF_ID ef_dspace = 5;
# line 119 "../GSE_MonoEnergy.st"
static const EF_ID ef_th = 6;
# line 120 "../GSE_MonoEnergy.st"
static const EF_ID ef_th_rbv = 7;
# line 121 "../GSE_MonoEnergy.st"
static const EF_ID ef_busy = 8;
# line 122 "../GSE_MonoEnergy.st"
static const EF_ID ef_id_harmonic = 9;
# line 123 "../GSE_MonoEnergy.st"
static const EF_ID ef_compute_mono_positions = 10;

/* Variable declarations */
# line 47 "../GSE_MonoEnergy.st"
static	char *calibrationFile;
# line 50 "../GSE_MonoEnergy.st"
static	double y2;
# line 51 "../GSE_MonoEnergy.st"
static	int y2_done;
# line 52 "../GSE_MonoEnergy.st"
static	int y2_stop;
# line 53 "../GSE_MonoEnergy.st"
static	double y2_mvmin;
# line 56 "../GSE_MonoEnergy.st"
static	double th;
# line 57 "../GSE_MonoEnergy.st"
static	double th_rbv;
# line 58 "../GSE_MonoEnergy.st"
static	int th_set;
# line 59 "../GSE_MonoEnergy.st"
static	int th_done;
# line 60 "../GSE_MonoEnergy.st"
static	int th_stop;
# line 63 "../GSE_MonoEnergy.st"
static	double id_val;
# line 64 "../GSE_MonoEnergy.st"
static	double id_rbv;
# line 65 "../GSE_MonoEnergy.st"
static	double id_gap;
# line 66 "../GSE_MonoEnergy.st"
static	double id_gap_rbv;
# line 67 "../GSE_MonoEnergy.st"
static	int id_harmonic;
# line 68 "../GSE_MonoEnergy.st"
static	int id_busy;
# line 69 "../GSE_MonoEnergy.st"
static	int id_stop;
# line 70 "../GSE_MonoEnergy.st"
static	double id_start_gap;
# line 71 "../GSE_MonoEnergy.st"
static	double id_end_gap;
# line 74 "../GSE_MonoEnergy.st"
static	double en;
# line 75 "../GSE_MonoEnergy.st"
static	double en_rbv;
# line 76 "../GSE_MonoEnergy.st"
static	double dspace;
# line 77 "../GSE_MonoEnergy.st"
static	double height;
# line 78 "../GSE_MonoEnergy.st"
static	double width;
# line 79 "../GSE_MonoEnergy.st"
static	int verbose;
# line 80 "../GSE_MonoEnergy.st"
static	int en_abort;
# line 82 "../GSE_MonoEnergy.st"
static	double en_timeout;
# line 83 "../GSE_MonoEnergy.st"
static	int en_busy;
# line 84 "../GSE_MonoEnergy.st"
static	int en_set;
# line 87 "../GSE_MonoEnergy.st"
static	int fb_use;
# line 88 "../GSE_MonoEnergy.st"
static	int fb_is_on;
# line 89 "../GSE_MonoEnergy.st"
static	int fb_locked;
# line 92 "../GSE_MonoEnergy.st"
static	int id_track;
# line 93 "../GSE_MonoEnergy.st"
static	int theta_track;
# line 94 "../GSE_MonoEnergy.st"
static	int id_wait;
# line 95 "../GSE_MonoEnergy.st"
static	double id_offset;
# line 96 "../GSE_MonoEnergy.st"
static	int id_set_off;
# line 97 "../GSE_MonoEnergy.st"
static	int id_harm_num;
# line 98 "../GSE_MonoEnergy.st"
static	int id_control_mode;
# line 101 "../GSE_MonoEnergy.st"
static	int num_mono_positions;
# line 102 "../GSE_MonoEnergy.st"
static	int compute_mono_positions;
# line 103 "../GSE_MonoEnergy.st"
static	double mono_angles[10000];
# line 104 "../GSE_MonoEnergy.st"
static	double mono_heights[10000];
# line 109 "../GSE_MonoEnergy.st"
static	int y2_track;
# line 110 "../GSE_MonoEnergy.st"
static	double y2_off;
# line 126 "../GSE_MonoEnergy.st"
static	double d2r;
# line 127 "../GSE_MonoEnergy.st"
static	double r2d;
# line 128 "../GSE_MonoEnergy.st"
static	double mil;
# line 129 "../GSE_MonoEnergy.st"
static	double hc;
# line 130 "../GSE_MonoEnergy.st"
static	double omega;
# line 131 "../GSE_MonoEnergy.st"
static	double en_rbv_new;
# line 132 "../GSE_MonoEnergy.st"
static	int en_moving;
# line 134 "../GSE_MonoEnergy.st"
static	double en_min;
# line 135 "../GSE_MonoEnergy.st"
static	double en_max;
# line 136 "../GSE_MonoEnergy.st"
static	double th_min;
# line 137 "../GSE_MonoEnergy.st"
static	double th_max;
# line 138 "../GSE_MonoEnergy.st"
static	double tiny;
# line 139 "../GSE_MonoEnergy.st"
static	double y2_old;
# line 140 "../GSE_MonoEnergy.st"
static	double y2_new;
# line 141 "../GSE_MonoEnergy.st"
static	int move_busy;
# line 142 "../GSE_MonoEnergy.st"
static	int wait_count;
# line 143 "../GSE_MonoEnergy.st"
static	int timeout_ticks;
# line 144 "../GSE_MonoEnergy.st"
static	int i;
# line 145 "../GSE_MonoEnergy.st"
static	int status;
# line 146 "../GSE_MonoEnergy.st"
static	double energy;
# line 147 "../GSE_MonoEnergy.st"
static	double gap;
# line 148 "../GSE_MonoEnergy.st"
static	double gap_step;


/* Function declarations */

#define seqg_var (*(struct seqg_vars *const *)seqg_env)

/* Program init func */
static void seqg_init(PROG_ID seqg_env)
{
}

/****** Code for state "init" in state set "GSE_MonoEnergy" ******/

/* Event function for state "init" in state set "GSE_MonoEnergy" */
static seqBool seqg_event_GSE_MonoEnergy_0_init(SS_ID seqg_env, int *seqg_ptrn, int *seqg_pnst)
{
	if (TRUE)
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 0;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "init" in state set "GSE_MonoEnergy" */
static void seqg_action_GSE_MonoEnergy_0_init(SS_ID seqg_env, int seqg_trn, int *seqg_pnst)
{
	switch(seqg_trn)
	{
	case 0:
		{
# line 155 "../GSE_MonoEnergy.st"
			printf("  GSE MonoEnergy > Energy State Set initializing \n");
# line 156 "../GSE_MonoEnergy.st"
			en_busy = 1;
# line 157 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 26/*en_busy*/, DEFAULT, DEFAULT_TIMEOUT);
# line 158 "../GSE_MonoEnergy.st"
			if ((dspace < 0.001) || (dspace > 1000.))
			{
# line 159 "../GSE_MonoEnergy.st"
				dspace = 3.135485;
# line 160 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 20/*dspace*/, DEFAULT, DEFAULT_TIMEOUT);
			}
# line 162 "../GSE_MonoEnergy.st"
			r2d = 57.29577951308;
# line 162 "../GSE_MonoEnergy.st"
			d2r = 1. / r2d;
# line 162 "../GSE_MonoEnergy.st"
			mil = 0.001;
# line 163 "../GSE_MonoEnergy.st"
			hc = 12398.42;
# line 164 "../GSE_MonoEnergy.st"
			omega = hc / (2 * dspace);
# line 165 "../GSE_MonoEnergy.st"
			en_min = 2200.00;
# line 166 "../GSE_MonoEnergy.st"
			en_max = 150000.00;
# line 167 "../GSE_MonoEnergy.st"
			th_min = r2d * asin(omega / en_max);
# line 168 "../GSE_MonoEnergy.st"
			th_max = r2d * asin(omega / en_min);
# line 169 "../GSE_MonoEnergy.st"
			tiny = 2.e-6;
# line 172 "../GSE_MonoEnergy.st"
			if (th < th_min)
# line 172 "../GSE_MonoEnergy.st"
				th = th_min;
# line 173 "../GSE_MonoEnergy.st"
			en = omega / sin(th * d2r);
# line 174 "../GSE_MonoEnergy.st"
			if (th_rbv < th_min)
# line 174 "../GSE_MonoEnergy.st"
				th_rbv = th_min;
# line 175 "../GSE_MonoEnergy.st"
			en_rbv = omega / sin(th_rbv * d2r);
# line 176 "../GSE_MonoEnergy.st"
			en = en_rbv;
# line 177 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 18/*en*/, DEFAULT, DEFAULT_TIMEOUT);
# line 177 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 19/*en_rbv*/, DEFAULT, DEFAULT_TIMEOUT);
# line 178 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 178 "../GSE_MonoEnergy.st"
				printf("  En(init)> mono angle, energy = %12.6f %12.6f\n", th_rbv, en_rbv);
			}
# line 181 "../GSE_MonoEnergy.st"
			id_offset = id_val - (en * mil);
# line 182 "../GSE_MonoEnergy.st"
			if (id_offset > 5000.)
# line 182 "../GSE_MonoEnergy.st"
				id_offset = 50.0;
# line 183 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 34/*id_offset*/, DEFAULT, DEFAULT_TIMEOUT);
# line 184 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 184 "../GSE_MonoEnergy.st"
				printf("   En(init)> ID energy, offset = %12.6f %12.6f\n", id_rbv, id_offset);
			}
# line 185 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_id_set_off);
# line 188 "../GSE_MonoEnergy.st"
			calibrationFile = seq_macValueGet(seqg_env, "CAL");
# line 189 "../GSE_MonoEnergy.st"
			GSE_MonoReadCalibration(calibrationFile);
# line 191 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_en);
# line 192 "../GSE_MonoEnergy.st"
			en_busy = 0;
# line 193 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 26/*en_busy*/, DEFAULT, DEFAULT_TIMEOUT);
# line 194 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 194 "../GSE_MonoEnergy.st"
				printf("   En(init)> done initializing\n");
			}
# line 195 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_th);
# line 196 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_busy);
		}
		return;
	}
}

/****** Code for state "monitor_changes" in state set "GSE_MonoEnergy" ******/

/* Event function for state "monitor_changes" in state set "GSE_MonoEnergy" */
static seqBool seqg_event_GSE_MonoEnergy_0_monitor_changes(SS_ID seqg_env, int *seqg_ptrn, int *seqg_pnst)
{
# line 202 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_en))
	{
		*seqg_pnst = 2;
		*seqg_ptrn = 0;
		return TRUE;
	}
# line 306 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_th) && (theta_track != 0))
	{
		*seqg_pnst = 2;
		*seqg_ptrn = 1;
		return TRUE;
	}
# line 364 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_busy))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 2;
		return TRUE;
	}
# line 372 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_th_rbv))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 3;
		return TRUE;
	}
# line 388 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_id_set_off))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 4;
		return TRUE;
	}
# line 401 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_dspace))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 5;
		return TRUE;
	}
# line 415 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_width))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 6;
		return TRUE;
	}
# line 424 "../GSE_MonoEnergy.st"
	if (seq_efTestAndClear(seqg_env, ef_compute_mono_positions) && (compute_mono_positions == 1))
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 7;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "monitor_changes" in state set "GSE_MonoEnergy" */
static void seqg_action_GSE_MonoEnergy_0_monitor_changes(SS_ID seqg_env, int seqg_trn, int *seqg_pnst)
{
	switch(seqg_trn)
	{
	case 0:
		{
# line 219 "../GSE_MonoEnergy.st"
			en_moving = 1;
# line 222 "../GSE_MonoEnergy.st"
			if (en < 0.0)
# line 222 "../GSE_MonoEnergy.st"
				en = -en;
# line 223 "../GSE_MonoEnergy.st"
			if (en < 500.0)
# line 223 "../GSE_MonoEnergy.st"
				en = en * 1000.;
# line 224 "../GSE_MonoEnergy.st"
			if (en < en_min)
# line 224 "../GSE_MonoEnergy.st"
				en = en_min;
# line 225 "../GSE_MonoEnergy.st"
			if (en > en_max)
# line 225 "../GSE_MonoEnergy.st"
				en = en_max;
# line 226 "../GSE_MonoEnergy.st"
			if (en_set)
			{
# line 227 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 227 "../GSE_MonoEnergy.st"
					printf("   En(set)> mono energy-> %12.6f\n", en);
				}
# line 228 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 18/*en*/, DEFAULT, DEFAULT_TIMEOUT);
# line 229 "../GSE_MonoEnergy.st"
				th = asin(omega / en) * r2d;
# line 230 "../GSE_MonoEnergy.st"
				th_set = 1;
# line 230 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 6/*th_set*/, DEFAULT, DEFAULT_TIMEOUT);
# line 231 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 4/*th*/, DEFAULT, DEFAULT_TIMEOUT);
# line 232 "../GSE_MonoEnergy.st"
				th_set = 0;
# line 232 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 6/*th_set*/, DEFAULT, DEFAULT_TIMEOUT);
# line 233 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 233 "../GSE_MonoEnergy.st"
					printf("   En(set)> mono angle -> %12.6f\n", th);
				}
			}
			else
			{
# line 236 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 236 "../GSE_MonoEnergy.st"
					printf("  En(move)> monoE->%12.6f", en);
				}
# line 239 "../GSE_MonoEnergy.st"
				if (id_track)
				{
# line 240 "../GSE_MonoEnergy.st"
					if (id_control_mode == 0)
					{
# line 241 "../GSE_MonoEnergy.st"
						id_val = (id_offset + en * mil);
# line 242 "../GSE_MonoEnergy.st"
						if ((id_val < 0.) || (id_val > 5000.))
# line 242 "../GSE_MonoEnergy.st"
							id_val = id_rbv;
# line 244 "../GSE_MonoEnergy.st"
						id_harmonic = id_harm_num;
# line 245 "../GSE_MonoEnergy.st"
						seq_pvPutTmo(seqg_env, 13/*id_harmonic*/, DEFAULT, DEFAULT_TIMEOUT);
# line 249 "../GSE_MonoEnergy.st"
						if (id_busy)
						{
# line 250 "../GSE_MonoEnergy.st"
							if (verbose)
							{
# line 250 "../GSE_MonoEnergy.st"
								printf(" clear id_busy");
							}
# line 251 "../GSE_MonoEnergy.st"
							id_stop = 1;
# line 252 "../GSE_MonoEnergy.st"
							seq_pvPutTmo(seqg_env, 15/*id_stop*/, DEFAULT, DEFAULT_TIMEOUT);
						}
# line 255 "../GSE_MonoEnergy.st"
						seq_pvPutTmo(seqg_env, 9/*id_val*/, DEFAULT, DEFAULT_TIMEOUT);
# line 256 "../GSE_MonoEnergy.st"
						if (verbose)
						{
# line 256 "../GSE_MonoEnergy.st"
							printf(", id_energy->%12.6f", id_val);
						}
					}
					else
					{
# line 261 "../GSE_MonoEnergy.st"
						if (id_busy)
						{
# line 262 "../GSE_MonoEnergy.st"
							if (verbose)
							{
# line 262 "../GSE_MonoEnergy.st"
								printf(" clear id_busy");
							}
# line 263 "../GSE_MonoEnergy.st"
							id_stop = 1;
# line 264 "../GSE_MonoEnergy.st"
							seq_pvPutTmo(seqg_env, 15/*id_stop*/, DEFAULT, DEFAULT_TIMEOUT);
						}
# line 266 "../GSE_MonoEnergy.st"
						status = GSE_MonoEnergyToGap(id_harm_num, en, &gap);
# line 267 "../GSE_MonoEnergy.st"
						if (status == 0)
						{
# line 268 "../GSE_MonoEnergy.st"
							id_gap = id_offset + gap;
# line 269 "../GSE_MonoEnergy.st"
							seq_pvPutTmo(seqg_env, 11/*id_gap*/, DEFAULT, DEFAULT_TIMEOUT);
# line 270 "../GSE_MonoEnergy.st"
							if (verbose)
							{
# line 270 "../GSE_MonoEnergy.st"
								printf(", id_gap->%12.6f", id_gap);
							}
						}
						else
						{
# line 272 "../GSE_MonoEnergy.st"
							printf("Error calling GSE_monoEnergyToGap for harmonic=%d energy=%f\n", id_harm_num, en);
						}
					}
				}
# line 278 "../GSE_MonoEnergy.st"
				th = (asin(omega / en) * r2d) - tiny;
# line 279 "../GSE_MonoEnergy.st"
				if (th < th_min)
# line 279 "../GSE_MonoEnergy.st"
					th = th_min;
# line 280 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 280 "../GSE_MonoEnergy.st"
					printf(",  mono_angle->%12.6f\n", th);
				}
# line 281 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 4/*th*/, DEFAULT, DEFAULT_TIMEOUT);
# line 284 "../GSE_MonoEnergy.st"
				if (y2_track)
				{
# line 285 "../GSE_MonoEnergy.st"
					width = height / (2 * cos(th * d2r));
# line 286 "../GSE_MonoEnergy.st"
					seq_pvPutTmo(seqg_env, 22/*width*/, DEFAULT, DEFAULT_TIMEOUT);
# line 287 "../GSE_MonoEnergy.st"
					y2_old = y2;
# line 288 "../GSE_MonoEnergy.st"
					y2_new = y2_off + width;
# line 289 "../GSE_MonoEnergy.st"
					if (fabs(y2_new - y2_old) > y2_mvmin)
					{
# line 290 "../GSE_MonoEnergy.st"
						y2 = y2_new;
# line 291 "../GSE_MonoEnergy.st"
						seq_pvPutTmo(seqg_env, 0/*y2*/, DEFAULT, DEFAULT_TIMEOUT);
					}
# line 293 "../GSE_MonoEnergy.st"
					if (verbose)
					{
# line 294 "../GSE_MonoEnergy.st"
						printf("  En(move)> 2nd XTAL y2->%12.6f, height->%12.6f\n", y2, height);
					}
				}
			}
		}
		return;
	case 1:
		{
# line 307 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 307 "../GSE_MonoEnergy.st"
				printf("  En(mono)> Mono angle changed: %12.6f\n", th);
			}
# line 308 "../GSE_MonoEnergy.st"
			if (th < th_min)
			{
# line 309 "../GSE_MonoEnergy.st"
				th = th_min;
			}
# line 311 "../GSE_MonoEnergy.st"
			en = omega / sin(th * d2r);
# line 313 "../GSE_MonoEnergy.st"
			en_moving = 1;
# line 314 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 314 "../GSE_MonoEnergy.st"
				printf("theta event:  en_busy is %d \n", en_busy);
			}
# line 317 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 18/*en*/, DEFAULT, DEFAULT_TIMEOUT);
# line 319 "../GSE_MonoEnergy.st"
			if (th_rbv < th_min)
# line 319 "../GSE_MonoEnergy.st"
				th_rbv = th_min;
# line 320 "../GSE_MonoEnergy.st"
			en_rbv = omega / sin(th_rbv * d2r);
# line 321 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 19/*en_rbv*/, DEFAULT, DEFAULT_TIMEOUT);
# line 322 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_en);
# line 323 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_th);
# line 326 "../GSE_MonoEnergy.st"
			if (y2_track)
			{
# line 327 "../GSE_MonoEnergy.st"
				width = height / (2 * cos(th * d2r));
# line 328 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 22/*width*/, DEFAULT, DEFAULT_TIMEOUT);
# line 329 "../GSE_MonoEnergy.st"
				y2_old = y2;
# line 330 "../GSE_MonoEnergy.st"
				y2_new = y2_off + width;
# line 331 "../GSE_MonoEnergy.st"
				if (fabs(y2_new - y2_old) > y2_mvmin)
				{
# line 332 "../GSE_MonoEnergy.st"
					y2 = y2_new;
# line 333 "../GSE_MonoEnergy.st"
					seq_pvPutTmo(seqg_env, 0/*y2*/, DEFAULT, DEFAULT_TIMEOUT);
				}
# line 335 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 336 "../GSE_MonoEnergy.st"
					printf("  En(move)> 2nd XTAL y2,width,height -> %12.6f %12.6f %12.6f\n", y2, width, height);
				}
			}
# line 340 "../GSE_MonoEnergy.st"
			if (id_track)
			{
# line 341 "../GSE_MonoEnergy.st"
				if (id_control_mode == 0)
				{
# line 343 "../GSE_MonoEnergy.st"
					id_harmonic = id_harm_num;
# line 344 "../GSE_MonoEnergy.st"
					seq_pvPutTmo(seqg_env, 13/*id_harmonic*/, DEFAULT, DEFAULT_TIMEOUT);
# line 345 "../GSE_MonoEnergy.st"
					id_val = (id_offset + en * mil);
# line 346 "../GSE_MonoEnergy.st"
					if ((id_val < 0.) || (id_val > 5000.))
# line 346 "../GSE_MonoEnergy.st"
						id_val = id_rbv;
# line 347 "../GSE_MonoEnergy.st"
					seq_pvPutTmo(seqg_env, 9/*id_val*/, DEFAULT, DEFAULT_TIMEOUT);
# line 348 "../GSE_MonoEnergy.st"
					if (verbose)
					{
# line 348 "../GSE_MonoEnergy.st"
						printf("  En(mono)> ID energy -> %12.6f\n", id_val);
					}
				}
				else
				{
# line 351 "../GSE_MonoEnergy.st"
					status = GSE_MonoEnergyToGap(id_harm_num, en, &gap);
# line 352 "../GSE_MonoEnergy.st"
					if (status == 0)
					{
# line 353 "../GSE_MonoEnergy.st"
						id_gap = id_offset + gap;
# line 354 "../GSE_MonoEnergy.st"
						seq_pvPutTmo(seqg_env, 11/*id_gap*/, DEFAULT, DEFAULT_TIMEOUT);
# line 355 "../GSE_MonoEnergy.st"
						if (verbose)
						{
# line 355 "../GSE_MonoEnergy.st"
							printf(", id_gap->%12.6f", id_gap);
						}
					}
					else
					{
# line 357 "../GSE_MonoEnergy.st"
						printf("Error calling GSE_monoEnergyToGap for harmonic=%d energy=%f\n", id_harm_num, en);
					}
				}
			}
		}
		return;
	case 2:
		{
# line 365 "../GSE_MonoEnergy.st"
			if (en_moving == 0)
			{
# line 366 "../GSE_MonoEnergy.st"
				en_busy = 0;
# line 367 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 26/*en_busy*/, DEFAULT, DEFAULT_TIMEOUT);
			}
		}
		return;
	case 3:
		{
# line 373 "../GSE_MonoEnergy.st"
			if (th_rbv < th_min)
# line 373 "../GSE_MonoEnergy.st"
				th_rbv = th_min;
# line 374 "../GSE_MonoEnergy.st"
			en_rbv_new = omega / sin(th_rbv * d2r);
# line 375 "../GSE_MonoEnergy.st"
			if (fabs(en_rbv_new - en_rbv) > tiny)
			{
# line 376 "../GSE_MonoEnergy.st"
				en_rbv = en_rbv_new;
# line 377 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 19/*en_rbv*/, DEFAULT, DEFAULT_TIMEOUT);
# line 378 "../GSE_MonoEnergy.st"
				if (verbose && (fabs(en_rbv_new - en_rbv) > 1.e-1))
				{
# line 380 "../GSE_MonoEnergy.st"
					printf("  En(th_rbv)> Readback angle, energy set to %12.6f %12.6f\n", th_rbv, en_rbv);
				}
			}
# line 383 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_en);
# line 384 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_th);
		}
		return;
	case 4:
		{
# line 389 "../GSE_MonoEnergy.st"
			if (id_set_off == 1)
			{
# line 390 "../GSE_MonoEnergy.st"
				id_offset = id_val - en * mil;
# line 391 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 34/*id_offset*/, DEFAULT, DEFAULT_TIMEOUT);
# line 392 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 392 "../GSE_MonoEnergy.st"
					printf("  En(id_track)> changed ID off => %12.6f\n", id_offset);
				}
			}
# line 394 "../GSE_MonoEnergy.st"
			id_set_off = 0;
# line 395 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 35/*id_set_off*/, DEFAULT, DEFAULT_TIMEOUT);
# line 396 "../GSE_MonoEnergy.st"
			seq_efClear(seqg_env, ef_id_set_off);
		}
		return;
	case 5:
		{
# line 402 "../GSE_MonoEnergy.st"
			if (dspace < 0.0)
# line 402 "../GSE_MonoEnergy.st"
				dspace = -dspace;
# line 403 "../GSE_MonoEnergy.st"
			if (dspace > 100.0)
# line 403 "../GSE_MonoEnergy.st"
				dspace = dspace / 1000.;
# line 404 "../GSE_MonoEnergy.st"
			if (dspace < 0.01)
# line 404 "../GSE_MonoEnergy.st"
				dspace = dspace * 1000.;
# line 405 "../GSE_MonoEnergy.st"
			omega = hc / (2 * dspace);
# line 406 "../GSE_MonoEnergy.st"
			en_min = 2200.000;
# line 407 "../GSE_MonoEnergy.st"
			en_max = 150000.00;
# line 408 "../GSE_MonoEnergy.st"
			th_min = r2d * asin(omega / en_max);
# line 409 "../GSE_MonoEnergy.st"
			th_max = r2d * asin(omega / en_min);
# line 410 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 20/*dspace*/, DEFAULT, DEFAULT_TIMEOUT);
# line 411 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 411 "../GSE_MonoEnergy.st"
				printf("  En(dspace) => %12.6f\n", dspace);
			}
		}
		return;
	case 6:
		{
# line 416 "../GSE_MonoEnergy.st"
			if (width < 0.0)
# line 416 "../GSE_MonoEnergy.st"
				width = -width;
# line 417 "../GSE_MonoEnergy.st"
			if (width > 80.0)
# line 417 "../GSE_MonoEnergy.st"
				width = 80.0;
# line 418 "../GSE_MonoEnergy.st"
			if (width < 5.)
# line 418 "../GSE_MonoEnergy.st"
				width = 5.0;
# line 419 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 22/*width*/, DEFAULT, DEFAULT_TIMEOUT);
# line 420 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 420 "../GSE_MonoEnergy.st"
				printf("  En(width) => %12.6f\n", width);
			}
		}
		return;
	case 7:
		{
# line 425 "../GSE_MonoEnergy.st"
			if (num_mono_positions > 10000)
			{
# line 426 "../GSE_MonoEnergy.st"
				num_mono_positions = 10000;
# line 427 "../GSE_MonoEnergy.st"
				seq_pvPutTmo(seqg_env, 38/*num_mono_positions*/, DEFAULT, DEFAULT_TIMEOUT);
			}
# line 429 "../GSE_MonoEnergy.st"
			gap_step = (id_end_gap - id_start_gap) / (num_mono_positions - 1);
# line 430 "../GSE_MonoEnergy.st"
			if (verbose)
			{
# line 430 "../GSE_MonoEnergy.st"
				printf("  En(compute_mono_positions) gap_start=%f, gap_stop=%f, gap_step=%f\n", id_start_gap, id_end_gap, gap_step);
			}
# line 431 "../GSE_MonoEnergy.st"
			for (i = 0; i < 10000; i++)
			{
# line 432 "../GSE_MonoEnergy.st"
				mono_angles[i] = 0;
# line 433 "../GSE_MonoEnergy.st"
				mono_heights[i] = 0;
			}
# line 435 "../GSE_MonoEnergy.st"
			for (i = 0; i < num_mono_positions; i++)
			{
# line 436 "../GSE_MonoEnergy.st"
				gap = id_start_gap + gap_step * i;
# line 437 "../GSE_MonoEnergy.st"
				status = GSE_MonoGapToEnergy(id_harmonic, gap, &energy);
# line 438 "../GSE_MonoEnergy.st"
				if (status)
				{
# line 439 "../GSE_MonoEnergy.st"
					printf(" En(compute_mono_positions), error converting gap=%f to energy for harmonic %d\n", gap, id_harmonic);
# line 440 "../GSE_MonoEnergy.st"
					energy = 0;
				}
# line 442 "../GSE_MonoEnergy.st"
				if (verbose)
				{
# line 442 "../GSE_MonoEnergy.st"
					printf("  En(compute_mono_positions) i=%d, gap=%f, energy=%f\n", i, gap, energy);
				}
# line 443 "../GSE_MonoEnergy.st"
				mono_angles[i] = (asin(omega / energy) * r2d);
# line 444 "../GSE_MonoEnergy.st"
				if (y2_track)
				{
# line 445 "../GSE_MonoEnergy.st"
					mono_heights[i] = y2_off + height / (2 * cos(mono_angles[i] * d2r));
				}
				else
				{
# line 447 "../GSE_MonoEnergy.st"
					mono_heights[i] = y2;
				}
			}
# line 450 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 40/*mono_angles*/, DEFAULT, DEFAULT_TIMEOUT);
# line 451 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 41/*mono_heights*/, DEFAULT, DEFAULT_TIMEOUT);
# line 452 "../GSE_MonoEnergy.st"
			compute_mono_positions = 0;
# line 453 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 39/*compute_mono_positions*/, DEFAULT, DEFAULT_TIMEOUT);
		}
		return;
	}
}

/****** Code for state "wait_done" in state set "GSE_MonoEnergy" ******/

/* Entry function for state "wait_done" in state set "GSE_MonoEnergy" */
static void seqg_entry_GSE_MonoEnergy_0_wait_done(SS_ID seqg_env)
{
# line 461 "../GSE_MonoEnergy.st"
	move_busy = 1;
# line 462 "../GSE_MonoEnergy.st"
	timeout_ticks = (1000.0 * en_timeout) + 0.5;
# line 463 "../GSE_MonoEnergy.st"
	wait_count = 0;
}

/* Exit function for state "wait_done" in state set "GSE_MonoEnergy" */
static void seqg_exit_GSE_MonoEnergy_0_wait_done(SS_ID seqg_env)
{
# line 504 "../GSE_MonoEnergy.st"
	en_rbv = omega / sin(th_rbv * d2r);
# line 505 "../GSE_MonoEnergy.st"
	seq_pvPutTmo(seqg_env, 19/*en_rbv*/, DEFAULT, DEFAULT_TIMEOUT);
# line 506 "../GSE_MonoEnergy.st"
	seq_efClear(seqg_env, ef_th);
# line 507 "../GSE_MonoEnergy.st"
	seq_efClear(seqg_env, ef_th_rbv);
# line 508 "../GSE_MonoEnergy.st"
	seq_efClear(seqg_env, ef_width);
# line 509 "../GSE_MonoEnergy.st"
	seq_efClear(seqg_env, ef_busy);
# line 510 "../GSE_MonoEnergy.st"
	en_moving = 0;
# line 511 "../GSE_MonoEnergy.st"
	if (verbose)
	{
# line 511 "../GSE_MonoEnergy.st"
		printf("  En(move)> done\n");
	}
# line 512 "../GSE_MonoEnergy.st"
	en_busy = 0;
# line 512 "../GSE_MonoEnergy.st"
	seq_pvPutTmo(seqg_env, 26/*en_busy*/, DEFAULT, DEFAULT_TIMEOUT);
# line 513 "../GSE_MonoEnergy.st"
	seq_efClear(seqg_env, ef_busy);
}

/* Event function for state "wait_done" in state set "GSE_MonoEnergy" */
static seqBool seqg_event_GSE_MonoEnergy_0_wait_done(SS_ID seqg_env, int *seqg_ptrn, int *seqg_pnst)
{
# line 466 "../GSE_MonoEnergy.st"
	if (en_abort)
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 0;
		return TRUE;
	}
# line 481 "../GSE_MonoEnergy.st"
	if (seq_delay(seqg_env, 0.001))
	{
		*seqg_pnst = 2;
		*seqg_ptrn = 1;
		return TRUE;
	}
# line 499 "../GSE_MonoEnergy.st"
	if (move_busy == 0)
	{
		*seqg_pnst = 1;
		*seqg_ptrn = 2;
		return TRUE;
	}
	return FALSE;
}

/* Action function for state "wait_done" in state set "GSE_MonoEnergy" */
static void seqg_action_GSE_MonoEnergy_0_wait_done(SS_ID seqg_env, int seqg_trn, int *seqg_pnst)
{
	switch(seqg_trn)
	{
	case 0:
		{
# line 467 "../GSE_MonoEnergy.st"
			id_stop = 1;
# line 468 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 15/*id_stop*/, DEFAULT, DEFAULT_TIMEOUT);
# line 469 "../GSE_MonoEnergy.st"
			th_stop = 0;
# line 470 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 8/*th_stop*/, SYNC, DEFAULT_TIMEOUT);
# line 471 "../GSE_MonoEnergy.st"
			th_stop = 3;
# line 472 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 8/*th_stop*/, DEFAULT, DEFAULT_TIMEOUT);
# line 473 "../GSE_MonoEnergy.st"
			y2_stop = 0;
# line 474 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 2/*y2_stop*/, SYNC, DEFAULT_TIMEOUT);
# line 475 "../GSE_MonoEnergy.st"
			y2_stop = 3;
# line 476 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 2/*y2_stop*/, DEFAULT, DEFAULT_TIMEOUT);
# line 477 "../GSE_MonoEnergy.st"
			en_abort = 0;
# line 478 "../GSE_MonoEnergy.st"
			seq_pvPutTmo(seqg_env, 24/*en_abort*/, DEFAULT, DEFAULT_TIMEOUT);
		}
		return;
	case 1:
		{
# line 485 "../GSE_MonoEnergy.st"
			move_busy = ((y2_track) && (y2_done == 0)) || (th_done == 0) || (id_busy && id_wait);
# line 486 "../GSE_MonoEnergy.st"
			if (fb_is_on && fb_use && (fb_locked == 0))
# line 486 "../GSE_MonoEnergy.st"
				move_busy = 1;
# line 487 "../GSE_MonoEnergy.st"
			if (wait_count > timeout_ticks)
# line 487 "../GSE_MonoEnergy.st"
				move_busy = 0;
# line 488 "../GSE_MonoEnergy.st"
			if (verbose && (wait_count % 100 == 0))
			{
# line 489 "../GSE_MonoEnergy.st"
				printf("  En(wait): count/timeout=%4.4d/%4.4d", wait_count, timeout_ticks);
# line 491 "../GSE_MonoEnergy.st"
				printf(", busy=%d, id_done=%d, th_done=%d, y2_done=%d", move_busy, !(id_busy && id_wait), th_done, y2_done);
# line 492 "../GSE_MonoEnergy.st"
				if (fb_is_on)
				{
# line 493 "../GSE_MonoEnergy.st"
					printf(", feedback is on, locked=%d", fb_locked);
				}
# line 495 "../GSE_MonoEnergy.st"
				printf("\n");
			}
		}
		return;
	case 2:
		{
		}
		return;
	}
}

#undef seqg_var

/************************ Tables ************************/

/* Channel table */
static seqChan seqg_chans[] = {
	/* chName, offset, varName, varType, count, eventNum, efId, monitored, queueSize, queueIndex */
	{"{MY}.VAL", (size_t)&y2, "y2", P_DOUBLE, 1, 11, 0, 1, 0, 0},
	{"{MY}.DMOV", (size_t)&y2_done, "y2_done", P_INT, 1, 12, 0, 1, 0, 0},
	{"{MY}.SPMG", (size_t)&y2_stop, "y2_stop", P_INT, 1, 13, 0, 0, 0, 0},
	{"{MONO}:y2_mvmin.VAL", (size_t)&y2_mvmin, "y2_mvmin", P_DOUBLE, 1, 14, 0, 1, 0, 0},
	{"{MTH}.VAL", (size_t)&th, "th", P_DOUBLE, 1, 15, 6, 1, 0, 0},
	{"{MTH}.RBV", (size_t)&th_rbv, "th_rbv", P_DOUBLE, 1, 16, 7, 1, 0, 0},
	{"{MTH}.SET", (size_t)&th_set, "th_set", P_INT, 1, 17, 0, 0, 0, 0},
	{"{MTH}.DMOV", (size_t)&th_done, "th_done", P_INT, 1, 18, 0, 1, 0, 0},
	{"{MTH}.SPMG", (size_t)&th_stop, "th_stop", P_INT, 1, 19, 0, 0, 0, 0},
	{"{ID}ScanEnergy.VAL", (size_t)&id_val, "id_val", P_DOUBLE, 1, 20, 0, 1, 0, 0},
	{"{ID}Energy.VAL", (size_t)&id_rbv, "id_rbv", P_DOUBLE, 1, 21, 0, 1, 0, 0},
	{"{ID}ScanGap.VAL", (size_t)&id_gap, "id_gap", P_DOUBLE, 1, 22, 0, 1, 0, 0},
	{"{ID}Gap.VAL", (size_t)&id_gap_rbv, "id_gap_rbv", P_DOUBLE, 1, 23, 0, 1, 0, 0},
	{"{ID}HarmonicValue.VAL", (size_t)&id_harmonic, "id_harmonic", P_INT, 1, 24, 9, 1, 0, 0},
	{"{ID}Busy.VAL", (size_t)&id_busy, "id_busy", P_INT, 1, 25, 0, 1, 0, 0},
	{"{ID}Stop.VAL", (size_t)&id_stop, "id_stop", P_INT, 1, 26, 0, 0, 0, 0},
	{"{ID}SSStartGap.VAL", (size_t)&id_start_gap, "id_start_gap", P_DOUBLE, 1, 27, 0, 1, 0, 0},
	{"{ID}SSEndGap.VAL", (size_t)&id_end_gap, "id_end_gap", P_DOUBLE, 1, 28, 0, 1, 0, 0},
	{"{MONO}:Energy.VAL", (size_t)&en, "en", P_DOUBLE, 1, 29, 1, 1, 0, 0},
	{"{MONO}:E_RBV", (size_t)&en_rbv, "en_rbv", P_DOUBLE, 1, 30, 0, 0, 0, 0},
	{"{MONO}:dspace.VAL", (size_t)&dspace, "dspace", P_DOUBLE, 1, 31, 5, 1, 0, 0},
	{"{MONO}:height.VAL", (size_t)&height, "height", P_DOUBLE, 1, 32, 0, 1, 0, 0},
	{"{MONO}:width.VAL", (size_t)&width, "width", P_DOUBLE, 1, 33, 4, 1, 0, 0},
	{"{MONO}:verbose.VAL", (size_t)&verbose, "verbose", P_INT, 1, 34, 0, 1, 0, 0},
	{"{MONO}:en_abort.VAL", (size_t)&en_abort, "en_abort", P_INT, 1, 35, 0, 0, 0, 0},
	{"{MONO}:timeout.VAL", (size_t)&en_timeout, "en_timeout", P_DOUBLE, 1, 36, 0, 0, 0, 0},
	{"{MONO}:Moving.VAL", (size_t)&en_busy, "en_busy", P_INT, 1, 37, 8, 1, 0, 0},
	{"{MONO}:SET.VAL", (size_t)&en_set, "en_set", P_INT, 1, 38, 0, 1, 0, 0},
	{"{MONO}:use_feedback.VAL", (size_t)&fb_use, "fb_use", P_INT, 1, 39, 0, 1, 0, 0},
	{"{FB}.FBON", (size_t)&fb_is_on, "fb_is_on", P_INT, 1, 40, 0, 1, 0, 0},
	{"{FB}Locked", (size_t)&fb_locked, "fb_locked", P_INT, 1, 41, 0, 1, 0, 0},
	{"{MONO}:id_track.VAL", (size_t)&id_track, "id_track", P_INT, 1, 42, 0, 1, 0, 0},
	{"{MONO}:theta_track.VAL", (size_t)&theta_track, "theta_track", P_INT, 1, 43, 0, 1, 0, 0},
	{"{MONO}:id_wait.VAL", (size_t)&id_wait, "id_wait", P_INT, 1, 44, 0, 1, 0, 0},
	{"{MONO}:id_off.VAL", (size_t)&id_offset, "id_offset", P_DOUBLE, 1, 45, 0, 1, 0, 0},
	{"{MONO}:id_set_off.VAL", (size_t)&id_set_off, "id_set_off", P_INT, 1, 46, 2, 1, 0, 0},
	{"{MONO}:id_harmonic.VAL", (size_t)&id_harm_num, "id_harm_num", P_INT, 1, 47, 0, 1, 0, 0},
	{"{MONO}:id_control_mode.VAL", (size_t)&id_control_mode, "id_control_mode", P_INT, 1, 48, 0, 1, 0, 0},
	{"{MONO}:num_mono_positions.VAL", (size_t)&num_mono_positions, "num_mono_positions", P_INT, 1, 49, 0, 1, 0, 0},
	{"{MONO}:compute_mono_positions.VAL", (size_t)&compute_mono_positions, "compute_mono_positions", P_INT, 1, 50, 10, 1, 0, 0},
	{"{MONO}:mono_angles.VAL", (size_t)&mono_angles, "mono_angles", P_DOUBLE, 10000, 51, 0, 0, 0, 0},
	{"{MONO}:mono_heights.VAL", (size_t)&mono_heights, "mono_heights", P_DOUBLE, 10000, 52, 0, 0, 0, 0},
	{"{MONO}:y2_track.VAL", (size_t)&y2_track, "y2_track", P_INT, 1, 53, 3, 1, 0, 0},
	{"{MONO}:y2_off.VAL", (size_t)&y2_off, "y2_off", P_DOUBLE, 1, 54, 0, 1, 0, 0},
};

/* Event masks for state set "GSE_MonoEnergy" */
static const seqMask seqg_mask_GSE_MonoEnergy_0_init[] = {
	0x00000000,
	0x00000000,
};
static const seqMask seqg_mask_GSE_MonoEnergy_0_monitor_changes[] = {
	0x000005f6,
	0x00040800,
};
static const seqMask seqg_mask_GSE_MonoEnergy_0_wait_done[] = {
	0x00000000,
	0x00000008,
};

/* State table for state set "GSE_MonoEnergy" */
static seqState seqg_states_GSE_MonoEnergy[] = {
	{
	/* state name */        "init",
	/* action function */   seqg_action_GSE_MonoEnergy_0_init,
	/* event function */    seqg_event_GSE_MonoEnergy_0_init,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  seqg_mask_GSE_MonoEnergy_0_init,
	/* state options */     (0)
	},
	{
	/* state name */        "monitor_changes",
	/* action function */   seqg_action_GSE_MonoEnergy_0_monitor_changes,
	/* event function */    seqg_event_GSE_MonoEnergy_0_monitor_changes,
	/* entry function */    0,
	/* exit function */     0,
	/* event mask array */  seqg_mask_GSE_MonoEnergy_0_monitor_changes,
	/* state options */     (0)
	},
	{
	/* state name */        "wait_done",
	/* action function */   seqg_action_GSE_MonoEnergy_0_wait_done,
	/* event function */    seqg_event_GSE_MonoEnergy_0_wait_done,
	/* entry function */    seqg_entry_GSE_MonoEnergy_0_wait_done,
	/* exit function */     seqg_exit_GSE_MonoEnergy_0_wait_done,
	/* event mask array */  seqg_mask_GSE_MonoEnergy_0_wait_done,
	/* state options */     (0)
	},
};

/* State set table */
static seqSS seqg_statesets[] = {
	{
	/* state set name */    "GSE_MonoEnergy",
	/* states */            seqg_states_GSE_MonoEnergy,
	/* number of states */  3
	},
};

/* Program table (global) */
seqProgram GSE_MonoEnergy = {
	/* magic number */      2002002,
	/* program name */      "GSE_MonoEnergy",
	/* channels */          seqg_chans,
	/* num. channels */     44,
	/* state sets */        seqg_statesets,
	/* num. state sets */   1,
	/* user var size */     0,
	/* param */             "MONO=13IDE:En, ID=ID13us:, MTH=13IDA:m65, MY=13IDA:m66, FB=13IDA:mono_pid2,CAL=13ID_DS_UndCalibration.xml",
	/* num. event flags */  10,
	/* encoded options */   (0 | OPT_CONN | OPT_NEWEF),
	/* init func */         seqg_init,
	/* entry func */        0,
	/* exit func */         0,
	/* num. queues */       0
};

/* Register sequencer commands and program */
#include "epicsExport.h"
static void GSE_MonoEnergyRegistrar (void) {
    seqRegisterSequencerCommands();
    seqRegisterSequencerProgram (&GSE_MonoEnergy);
}
epicsExportRegistrar(GSE_MonoEnergyRegistrar);
